Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 65519)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 65520)
@@ -24,8 +24,6 @@
 # include <QTimer>
 # ifdef VBOX_WS_WIN
-#  if QT_VERSION >= 0x050000
-#   include <QWindow>
-#  endif /* QT_VERSION >= 0x050000 */
-# endif /* VBOX_WS_WIN */
+#  include <QWindow>
+# endif
 
 /* GUI includes: */
@@ -62,7 +60,7 @@
 #endif /* VBOX_WS_MAC */
     , m_fWasMinimized(false)
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
+#ifdef VBOX_WS_X11
     , m_fIsMinimized(false)
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif
 {
 }
@@ -356,14 +354,8 @@
 #elif defined(VBOX_WS_WIN)
 
-# if QT_VERSION >= 0x050000
     /* Map window onto required screen: */
     windowHandle()->setScreen(qApp->screens().at(iHostScreen));
-# endif /* QT_VERSION >= 0x050000 */
     /* Set appropriate window size: */
     resize(workingArea.size());
-# if QT_VERSION < 0x050000
-    /* Move window onto required screen: */
-    move(workingArea.topLeft());
-# endif /* QT_VERSION < 0x050000 */
 
 #elif defined(VBOX_WS_X11)
@@ -545,5 +537,5 @@
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
 
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
+#ifdef VBOX_WS_X11
 void UIMachineWindowFullscreen::changeEvent(QEvent *pEvent)
 {
@@ -583,8 +575,7 @@
     UIMachineWindow::changeEvent(pEvent);
 }
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif /* VBOX_WS_X11 */
 
 #ifdef VBOX_WS_WIN
-# if QT_VERSION >= 0x050000
 void UIMachineWindowFullscreen::showEvent(QShowEvent *pEvent)
 {
@@ -598,5 +589,4 @@
     UIMachineWindow::showEvent(pEvent);
 }
-# endif /* QT_VERSION >= 0x050000 */
 #endif /* VBOX_WS_WIN */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.h	(revision 65519)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.h	(revision 65520)
@@ -102,15 +102,13 @@
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
 
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
-    /** Handles @a pEvent about state change. */
+#ifdef VBOX_WS_X11
+    /** X11: Handles @a pEvent about state change. */
     void changeEvent(QEvent *pEvent);
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif
 
 #ifdef VBOX_WS_WIN
-# if QT_VERSION >= 0x050000
     /** Win: Handles show @a pEvent. */
     void showEvent(QShowEvent *pEvent);
-# endif /* QT_VERSION >= 0x050000 */
-#endif /* VBOX_WS_WIN */
+#endif
 
 #if defined(VBOX_WS_WIN) || defined(VBOX_WS_X11)
@@ -129,9 +127,9 @@
       * Used to restore minimized state when the window shown again. */
     bool m_fWasMinimized;
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
-    /** Holds whether the window is currently minimized.
+#ifdef VBOX_WS_X11
+    /** X11: Holds whether the window is currently minimized.
       * Used to restore full-screen state when the window restored again. */
     bool m_fIsMinimized;
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif
 
     /** Factory support. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp	(revision 65519)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp	(revision 65520)
@@ -52,7 +52,7 @@
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
     , m_fWasMinimized(false)
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
+#ifdef VBOX_WS_X11
     , m_fIsMinimized(false)
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif
 {
 }
@@ -92,17 +92,6 @@
 
 #ifdef VBOX_WITH_TRANSLUCENT_SEAMLESS
-# if defined(VBOX_WS_MAC) && QT_VERSION < 0x050000
-    /* Using native API to enable translucent background for the Mac host.
-     * - We also want to disable window-shadows which is possible
-     *   using Qt::WA_MacNoShadow only since Qt 4.8,
-     *   while minimum supported version is 4.7.1 for now: */
-    ::darwinSetShowsWindowTransparent(this, true);
-# else /* !VBOX_WS_MAC || QT_VERSION >= 0x050000 */
-    /* Using Qt API to enable translucent background:
-     * - Under Win host Qt conflicts with 3D stuff (black seamless regions).
-     * - Under Mac host Qt doesn't allows to disable window-shadows
-     *   until version 4.8, but minimum supported version is 4.7.1 for now. */
+    /* Using Qt API to enable translucent background: */
     setAttribute(Qt::WA_TranslucentBackground);
-# endif /* !VBOX_WS_MAC || QT_VERSION >= 0x050000 */
 #endif /* VBOX_WITH_TRANSLUCENT_SEAMLESS */
 
@@ -185,5 +174,5 @@
     Q_UNUSED(workingArea);
 
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
+#ifdef VBOX_WS_X11
 
     /* Make sure we are located on corresponding host-screen: */
@@ -257,5 +246,5 @@
         placeOnScreen();
 
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
+#ifdef VBOX_WS_X11
         /* Show window: */
         if (!isMaximized())
@@ -307,5 +296,5 @@
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
 
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
+#ifdef VBOX_WS_X11
 void UIMachineWindowSeamless::changeEvent(QEvent *pEvent)
 {
@@ -345,8 +334,7 @@
     UIMachineWindow::changeEvent(pEvent);
 }
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif /* VBOX_WS_X11 */
 
 #ifdef VBOX_WS_WIN
-# if QT_VERSION >= 0x050000
 void UIMachineWindowSeamless::showEvent(QShowEvent *pEvent)
 {
@@ -360,5 +348,4 @@
     UIMachineWindow::showEvent(pEvent);
 }
-# endif /* QT_VERSION >= 0x050000 */
 #endif /* VBOX_WS_WIN */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.h	(revision 65519)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.h	(revision 65520)
@@ -74,15 +74,13 @@
 #endif /* VBOX_WS_WIN || VBOX_WS_X11 */
 
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
-    /** Handles @a pEvent about state change. */
+#ifdef VBOX_WS_X11
+    /** X11: Handles @a pEvent about state change. */
     void changeEvent(QEvent *pEvent);
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif
 
 #ifdef VBOX_WS_WIN
-# if QT_VERSION >= 0x050000
     /** Win: Handles show @a pEvent. */
     void showEvent(QShowEvent *pEvent);
-# endif /* QT_VERSION >= 0x050000 */
-#endif /* VBOX_WS_WIN */
+#endif
 
 #ifdef VBOX_WITH_MASKED_SEAMLESS
@@ -106,9 +104,9 @@
       * Used to restore minimized state when the window shown again. */
     bool m_fWasMinimized;
-#if defined(VBOX_WS_X11) && QT_VERSION >= 0x050000
-    /** Holds whether the window is currently minimized.
+#ifdef VBOX_WS_X11
+    /** X11: Holds whether the window is currently minimized.
       * Used to restore maximized state when the window restored again. */
     bool m_fIsMinimized;
-#endif /* VBOX_WS_X11 && QT_VERSION >= 0x050000 */
+#endif
 
     /** Factory support. */