Index: trunk/src/VBox/Devices/PC/vbox.dsl
===================================================================
--- trunk/src/VBox/Devices/PC/vbox.dsl	(revision 65581)
+++ trunk/src/VBox/Devices/PC/vbox.dsl	(revision 65582)
@@ -135,15 +135,15 @@
         // Local7 is the minimum of Str1 or Str2 length.
         //
-    
+
         Store(Arg0, Local0)
         Store(S2BF(Local0), Local0)
-    
+
         Store(S2BF(Arg1), Local1)
         Store(Zero, Local4)
-    
+
         Store(SLEN(Arg0), Local5)
         Store(SLEN(Arg1), Local6)
         Store(MIN(Local5, Local6), Local7)
-    
+
         While (LLess(Local4, Local7))
         {
@@ -161,8 +161,8 @@
                 }
             }
-    
+
             Increment(Local4)
         }
-    
+
         If (LLess(Local4, Local5))
         {
@@ -242,5 +242,5 @@
             // OS returns non-zero value in response to _OSI query if it
             // supports the interface. Newer Windows releases support older
-            // versions of the ACPI interface. 
+            // versions of the ACPI interface.
             If (_OSI("Windows 2001"))
             {
@@ -343,7 +343,7 @@
         USMC,  32, // if SMC enabled
         UFDC,  32, // if floppy controller enabled
-        SL2B,  32, // Serial2 base IO address  
+        SL2B,  32, // Serial2 base IO address
         SL2I,  32, // Serial2 IRQ
-        SL3B,  32, // Serial3 base IO address  
+        SL3B,  32, // Serial3 base IO address
         SL3I,  32, // Serial3 IRQ
         PMEM,  32,
@@ -360,11 +360,11 @@
         PCIB,  32, // PCI MCFG base start
         PCIL,  32, // PCI MCFG length
-        SL0B,  32, // Serial0 base IO address  
+        SL0B,  32, // Serial0 base IO address
         SL0I,  32, // Serial0 IRQ
-        SL1B,  32, // Serial1 base IO address  
+        SL1B,  32, // Serial1 base IO address
         SL1I,  32, // Serial1 IRQ
-        PP0B,  32, // Parallel0 base IO address  
+        PP0B,  32, // Parallel0 base IO address
         PP0I,  32, // Parallel0 IRQ
-        PP1B,  32, // Parallel1 base IO address  
+        PP1B,  32, // Parallel1 base IO address
         PP1I,  32, // Parallel1 IRQ
         Offset (0x80),
@@ -730,5 +730,5 @@
         Device (PCI0)
         {
-            
+
             Name (_HID, EisaId ("PNP0A03")) // PCI bus PNP id
             Method(_ADR, 0, NotSerialized)  // PCI address
@@ -739,5 +739,5 @@
             Name (_UID, 0x00)
 
-            // Method that returns routing table; also opens PCI to I/O APIC 
+            // Method that returns routing table; also opens PCI to I/O APIC
             // interrupt routing backdoor by writing 0xdead 0xbeef signature
             // to ISA bridge config space. See DevPCI.cpp/pciSetIrqInternal().
@@ -774,5 +774,5 @@
                     APDE,   8,
                 }
-              
+
                 // PCI MCFG MMIO ranges
                 Device (^PCIE)
@@ -804,5 +804,5 @@
                      }
                     }
-                }               
+                }
 
                 // Keyboard device
@@ -966,5 +966,5 @@
                     Name (CRS, ResourceTemplate ()
                     {
-                        IO (Decode16, 0x03F8, 0x03F8, 0x01, 0x08, _Y14) 
+                        IO (Decode16, 0x03F8, 0x03F8, 0x01, 0x08, _Y14)
                         IRQNoFlags (_Y15) {4}
                     })
@@ -980,5 +980,5 @@
                     }
                 }
-                
+
                 // Serial port 1
                 Device (^SRL1)
@@ -999,5 +999,5 @@
                     Name (CRS, ResourceTemplate ()
                     {
-                        IO (Decode16, 0x02F8, 0x02F8, 0x01, 0x08, _Y16) 
+                        IO (Decode16, 0x02F8, 0x02F8, 0x01, 0x08, _Y16)
                         IRQNoFlags (_Y17) {3}
                     })
@@ -1032,5 +1032,5 @@
                     Name (CRS, ResourceTemplate ()
                     {
-                        IO (Decode16, 0x03E8, 0x03E8, 0x01, 0x08, _Y22) 
+                        IO (Decode16, 0x03E8, 0x03E8, 0x01, 0x08, _Y22)
                         IRQNoFlags (_Y23) {3}
                     })
@@ -1128,5 +1128,5 @@
 
                 // Real Time Clock and CMOS (MC146818)
-                Device (RTC) 
+                Device (RTC)
                 {
                     Name (_HID, EisaId ("PNP0B00"))
@@ -1147,5 +1147,5 @@
 
                 // High Precision Event Timer
-                Device(HPET) 
+                Device(HPET)
                 {
                   Name (_HID,  EISAID("PNP0103"))
@@ -1153,10 +1153,10 @@
                   Name(_UID, 0)
 
-                  Method (_STA, 0, NotSerialized) 
+                  Method (_STA, 0, NotSerialized)
                   {
                        Return(UHPT)
                   }
 
-                  Name(CRS, ResourceTemplate() 
+                  Name(CRS, ResourceTemplate()
                   {
                       IRQNoFlags ()
@@ -1169,5 +1169,5 @@
                             )
                   })
-                
+
                   Method (_CRS, 0, NotSerialized)
                   {
@@ -1192,5 +1192,5 @@
                            0x0300,             // Range Maximum
                            0x01,               // Alignment
-                           0x20)               // Length                   
+                           0x20)               // Length
                     IRQNoFlags ()
                             {6}
@@ -1201,5 +1201,5 @@
                        Return (CRS)
                     }
-                 }                 
+                 }
              }
 
@@ -1298,15 +1298,15 @@
                 Method(_DSM, 4, NotSerialized)
                 {
-                    Store (Package (0x04)                                                                                                                              
-                    {                                                                                                                                              
-                        "layout-id",                                                                                                                               
-                        Buffer (0x04)                                                                                                                              
-                        {                                                                                                                                          
-                            /* 04 */    0x04, 0x00, 0x00, 0x00                                                                                                   
-                        },                                                                                                                                         
-                                                                                                                                                                   
-                        "PinConfigurations",                                                                                                                       
-                        Buffer (Zero) {}                                                                                                                           
-                    }, Local0)                                                                                                                                     
+                    Store (Package (0x04)
+                    {
+                        "layout-id",
+                        Buffer (0x04)
+                        {
+                            /* 04 */    0x04, 0x00, 0x00, 0x00
+                        },
+
+                        "PinConfigurations",
+                        Buffer (Zero) {}
+                    }, Local0)
                     if (LEqual (Arg0, ToUUID("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                     {
@@ -1315,23 +1315,23 @@
                             if (LEqual(Arg2, Zero))
                             {
-                                    Store (Buffer (0x01)                                                                                                                              
-                                        {                                                                                                                                          
+                                    Store (Buffer (0x01)
+                                        {
                                             0x03
                                         }
-                                    , Local0)                                                                                                                                     
-                                    Return (Local0)   
+                                    , Local0)
+                                    Return (Local0)
                             }
                             if (LEqual(Arg2, One))
                             {
-                                    Return (Local0)   
+                                    Return (Local0)
                             }
                         }
                     }
-                    Store (Buffer (0x01)                                                                                                                              
-                        {                                                                                                                                          
+                    Store (Buffer (0x01)
+                        {
                             0x0
                         }
-                    , Local0)                                                                                                                                     
-                    Return (Local0)   
+                    , Local0)
+                    Return (Local0)
                 }
 
@@ -1350,5 +1350,5 @@
                     }
                  }
-            }            
+            }
 
 