Index: trunk/src/VBox/Devices/Audio/testcase/tstAudioMixBuffer.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/testcase/tstAudioMixBuffer.cpp	(revision 65624)
+++ trunk/src/VBox/Devices/Audio/testcase/tstAudioMixBuffer.cpp	(revision 65635)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2016 Oracle Corporation
+ * Copyright (C) 2014-2017 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -46,10 +46,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          2,                        /* Channels */
-          44100,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 2 /* Channels */), /* Shift */
+          2,                                                                  /* Channels */
+          44100,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -150,10 +150,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          2,                        /* Channels */
-          44100,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 2 /* Channels */), /* Shift */
+          2,                                                                  /* Channels */
+          44100,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -169,10 +169,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          2,                        /* Channels */
-          22050,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 2 /* Channels */), /* Shift */
+          2,                                                                  /* Channels */
+          22050,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -189,10 +189,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          2,                        /* Channels */
-          48000,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 2 /* Channels */), /* Shift */
+          2,                                                                  /* Channels */
+          48000,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -276,10 +276,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 8,                        /* Bits */
-          false,                    /* Signed */
-          1,                        /* Shift */
-          1,                        /* Channels */
-          44100,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 8,                                                                 /* Bits */
+          false,                                                             /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(8 /* Bits */, 1 /* Channels */), /* Shift */
+          1,                                                                 /* Channels */
+          44100,                                                             /* Hz */
+          false                                                              /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -302,10 +302,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 8,                        /* Bits */
-          false,                    /* Signed */
-          1,                        /* Shift */
-          1,                        /* Channels */
-          22050,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 8,                                                                 /* Bits */
+          false,                                                             /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(8 /* Bits */, 1 /* Channels */), /* Shift */
+          1,                                                                 /* Channels */
+          22050,                                                             /* Hz */
+          false                                                              /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -387,10 +387,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          1,                        /* Channels */
-          44100,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 1 /* Channels */), /* Shift */
+          1,                                                                  /* Channels */
+          44100,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -406,10 +406,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          1,                        /* Channels */
-          22050,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 1 /* Channels */), /* Shift */
+          1,                                                                  /* Channels */
+          22050,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };
@@ -491,10 +491,10 @@
         PDMAUDIODIR_OUT,
         { PDMAUDIOPLAYBACKDEST_UNKNOWN },
-        { 16,                       /* Bits */
-          true,                     /* Signed */
-          1,                        /* Shift */
-          2,                        /* Channels */
-          44100,                    /* Hz */
-          false                     /* Swap Endian */ },
+        { 16,                                                                 /* Bits */
+          true,                                                               /* Signed */
+          PDMAUDIOPCMPROPS_MAKE_SHIFT_PARMS(16 /* Bits */, 2 /* Channels */), /* Shift */
+          2,                                                                  /* Channels */
+          44100,                                                              /* Hz */
+          false                                                               /* Swap Endian */ },
         0 /* cSampleBufferSize */
     };